﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Core.DB;

namespace 数据库封装类
{
    class Program
    {
        static void Main(string[] args)
        {
            var len = 200;
            DbHelp db = new DbHelp("local");

            db.ExecuteNonQuery(@"if exists ( select * from SysObjects where name = 'tab1' and xtype='u')
drop table tab1");

            db.ExecuteNonQuery(@"
create table tab1 (
[ID] [int] IDENTITY(1,1) NOT NULL,
[Name] [nvarchar](max) NULL,
[Home] [nvarchar](max) NULL,
)");
            Console.WriteLine("{0} 创建表完成", DateTime.Now);

            var time = DateTime.Now;
            //使用事务批量插入
            db.BeginTransation();
            for (var i = 0; i < len; i++)
            {
                db["Name"] = "cn";
                db["Home"] = "china";
                db.ExecuteNonQuery("insert into tab1 (Name,Home) values (@Name,@Home)");
            }
            db.Commit();
            Console.WriteLine("使用事务批量插入:{0}", (DateTime.Now - time).TotalSeconds);

            //批量插入 不使用事务
            time = DateTime.Now;
            for (var i = 0; i < len; i++)
            {
                db["Name"] = "cn";
                db["Home"] = "china";
                db.ExecuteNonQuery("insert into tab1 (Name,Home) values (@Name,@Home)");
            }
            Console.WriteLine("批量插入:{0}", (DateTime.Now - time).TotalSeconds);

            var count = db.Count("Select Count(*) from tab1");
            Console.WriteLine("统计总行数:{0}", count);

            db["PageEnd"] = 10;
            var dt = db.ExecuteSql(" Select top (@PageEnd) ROW_NUMBER() over (order by ID desc) RN , * from tab1 ");

            dt = db.ExecuteSql("Select * from tab1 order by ID desc", 0, 15, out count);

            using (var reader = db.ExecuteReader("Select * from tab1 order by ID desc", 0, 15))
            {
                while (reader.Read())
                {
                    Console.WriteLine("ID:{0} Name:{1}", reader["ID"], reader["Name"]);
                }
            }

            using (var reader = db.ExecuteReader("Select * from tab1 order by ID desc", 0, 15, out count))
            {
                Console.WriteLine("读取的行数为:{0}", count);
                while (reader.Read())
                {
                    Console.WriteLine("ID:{0} Name:{1}", reader["ID"], reader["Name"]);
                }
            }
        }
    }
}
